<template>
  <span>
    <slot v-if="authorized"></slot>
    <slot v-else name="unauthorized"></slot>
    <b-alert :show="showLock" variant="warning">
      <font-awesome-icon :icon="['fas', 'lock']" /><span class="ml-2"
        >Unauthorized.</span
      >
    </b-alert>
  </span>
</template>

<script>
import { mapGetters } from 'vuex';

export default {
  props: {
    roles: {
      type: Array,
      default: () => {
        return [];
      },
    },
    displayLock: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    ...mapGetters(['hasAnyRole']),
    authorized() {
      return this.hasAnyRole(this.roles);
    },
    showLock() {
      return this.displayLock && !this.authorized;
    },
  },
};
</script>
